EventSettings (Java SE 26 & JDK 26)
Description: declaration: module: jdk.jfr, package: jdk.jfr, class: EventSettings
Keywords: jdk.jfr.EventSettings class

# Class EventSettings

java.lang.Object
jdk.jfr.EventSettings

public abstract class EventSettings extends Object
Convenience class for applying event settings to a recording.

An `EventSettings` object for a recording can be obtained by invoking the `Recording.enable(String)` method which is configured using method chaining.

The following example shows how to use the `EventSettings` class.

    try (Recording r = new Recording()) {
        r.enable("jdk.CPULoad")
         .withPeriod(Duration.ofSeconds(1));
        r.enable("jdk.FileWrite")
         .withoutStackTrace()
         .withThreshold(Duration.ofNanos(10));
        r.start();
        Thread.sleep(10_000);
        r.stop();
        r.dump(Files.createTempFile("recording", ".jfr"));
    }

Since:
  9

- ## Method Summary

  Modifier and Type
  Method
  Description
  `abstract EventSettings`
  `with(String name, String value)`
  Sets a setting value for the event that is associated with this event setting.
  `final EventSettings`
  `withoutStackTrace()`
  Disables stack traces for the event that is associated with this event setting.
  `final EventSettings`
  `withoutThreshold()`
  Specifies that a threshold is not used.
  `final EventSettings`
  `withPeriod(Duration duration)`
  Sets the interval for the event that is associated with this event setting.
  `final EventSettings`
  `withStackTrace()`
  Enables stack traces for the event that is associated with this event setting.
  `final EventSettings`
  `withThreshold(Duration duration)`
  Sets the threshold for the event that is associated with this event setting.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Method Details

  - ### withStackTrace

    public final EventSettings withStackTrace()
    Enables stack traces for the event that is associated with this event setting.

    Equivalent to invoking the `with("stackTrace", "true")` method.

    Returns:
      event settings object for further configuration, not `null`

  - ### withoutStackTrace

    public final EventSettings withoutStackTrace()
    Disables stack traces for the event that is associated with this event setting.

    Equivalent to invoking the `with("stackTrace", "false")` method.

    Returns:
      event settings object for further configuration, not `null`

  - ### withoutThreshold

    public final EventSettings withoutThreshold()
    Specifies that a threshold is not used.

    This is a convenience method, equivalent to invoking the `with("threshold", "0 s")` method.

    Returns:
      event settings object for further configuration, not `null`

  - ### withPeriod

    public final EventSettings withPeriod(Duration duration)
    Sets the interval for the event that is associated with this event setting.
    Parameters:
      `duration` - the duration, not `null`
    Returns:
      event settings object for further configuration, not `null`

  - ### withThreshold

    public final EventSettings withThreshold(Duration duration)
    Sets the threshold for the event that is associated with this event setting.
    Parameters:
      `duration` - the duration, or `null` if no duration is used
    Returns:
      event settings object for further configuration, not `null`

  - ### with

    public abstract EventSettings with(String name, String value)
    Sets a setting value for the event that is associated with this event setting.
    Parameters:
      `name` - the name of the setting (for example, `"threshold"`)
      `value` - the value to set (for example `"20 ms"` not `null`)
    Returns:
      event settings object for further configuration, not `null`